# puzzle-scoreboard-extension

Browser extension for managing a puzzle contest from a Google Meet tab: https://puzzle-scoreboard.org.

This extension is only allowed to inject code in Google Meet pages (cf the `manifest.json` file).
It stores the following information in the local extension storage of the browser:
- start and end times of the current contest
- messages with timestamps that got sent during the contest

There's a button to delete all those data once the contest ended.

## Installation

To install the extension, you'll first need to download the code. Click on `Code`, then download an archive as ZIP or TAR.GZ, and extract it in some directory on your machine.

To install on chromium-based browsers (Google Chrome, Brave, ...):

1. Click on the extension button in your toolbar (the puzzle icon), or visit `chrome://extensions`
2. Click on `Manage extensions`
3. Click on the `Developer mode` switch on the top-right corner of the page
4. Click on `Load unpacked` button on the top-left corner of the page
5. Select the directory where you downloaded the code

To install on gecko-based browsers (Mozilla Firefox, LibreWolf, ...):

TODO: need to make this extension gecko-compatible.

## Usage

Once you have installed the extension in your favorite browser, click again on the puzzle icon in your toolbar to open it (you can also pin it so that it appears in the toolbar).

From the extension popup, you should be able to start a contest, end it, and reset all saved data.

When in a Google Meet tab, once a contest is started, all new messages with be automatically prepended by the time since start of the contest.
Those messages will also be saved in the `messages` section of the extension popup (so that they are kept in case you close the Google Meet tab by mistake).

## How it works

The extension will look for new messages in the Google Meet messages section, if opened, and assign times to them as soon as they appear there.

If you close the message section, the extension will still be able to log the times of incoming messages because they are appearing in notifications in the bottom right corner of the screen, but it won't actually assign them to messages and save them until you re-open the messages section.

Best is to keep that section open all along though if possible.

## Word of caution

Please note this work is technically dependent on the structure of Google Meet pages, if Google decides to completely rework them, the extension may break in unexpected ways.

However, Google Meet is a quite stable product, and such changes are very rare. So if you check things work nicely the day before your contest, or ideally a few hours right before, then it should be alright!
